<?php
session_start();

   /***********************************************************************
   *    Copyright  2002 - 2005 Hewlett-Packard Development Company, L.P. *
   ***********************************************************************/

$_SESSION["page"] = "errorlog.php";
//include "iocommand.php";
include "fefunctions.php";
$pid = $_REQUEST["pid"];
$language = GetLanguage();

$errorLogError = "";
$errorLogString = "";
$getErrorLogString = sprintf("<getErrorLog language='%s'/>", $language);
ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $getErrorLogString, $errorLogString, $errorLogError);
 
$oss = "";
$oss = sprintf("<html>\n<head>\n  <meta http-equiv='content-type' content='text/html; charset=UTF-8'>\n<TITLE>HP Insight Diagnostics</TITLE>\n");
$oss = $oss . sprintf("<link rel='stylesheet' type='text/css' href='stylesheets/main.css'>\n<SCRIPT LANGUAGE='JavaScript' SRC='menufunctions.js'>\n</SCRIPT>\n");
$oss = $oss . sprintf("</head><body onload='doLogMenuItem(1)'>\n<form name='errorLogForm' action=errorlog.php method='post'>\n");

$oss = $oss . sprintf("<div id='savePrompt' style='Visibility:hidden; display:none;'><table width=100%%>\n  <tr>\n");
$oss = $oss . sprintf("    <td width=300></td>\n<td>");

$oss = $oss . sprintf("                                 <input type='radio' name='location' value='floppy' checked> %s\n", TR("MSG_SAVE_TO_FLOPPY"));

if (IsOnline())
  $oss = $oss . sprintf("    <br><input type='radio' name='location' value='harddrive'> %s %s<br>\n", TR("MSG_SAVE_TO_HARD_DRIVE"), $_SESSION["diagsDirectory"]);

if (mountUSB("Transparent SCSI"))
  $oss = $oss . sprintf("                                 <br><input type='radio' name='location' value='diskonkey'> %s\n", TR("MSG_SAVE_TO_USB_KEY"));

if (mountUSB("Floppy"))
{
  $usbFloppy = true;
  $oss = $oss . sprintf("                                 <br><input type='radio' name='location' value='usb'> %s\n", TR("MSG_SAVE_TO_USB_FLOPPY"));
}

$oss = $oss . sprintf("    </td><td align=right><b>%s:</b> <input type=text name=filename id=filename onkeypress='document.onkeydown = submitenter'> ", TR("MSG_FILENAME"));
$oss = $oss . sprintf("<input type=button value=%s onclick='saveFile(\"2\");'></td>\n  </tr>\n</table>\n<hr></div>\n", TR("MSG_SAVE"));

$oss = $oss . sprintf("<table>\n  <tr valign=top>\n    <td class='head'>%s</td>\n  </tr>\n</table><hr>\n", TR("MSG_ERROR_LOG"));
$oss = $oss . sprintf("<table width=100%% cellspacing=0 cellpadding=0>\n  <tr class=heading>\n    <td class=heading width=150>%s, %s</td>\n", TR("MSG_DEVICE"), TR("MSG_TEST"));
$oss = $oss . sprintf("    <td class=heading width=100>%s</td>\n", TR("MSG_DESCRIPTION"));
$oss = $oss . sprintf("    <td class=heading width=300>%s</td>\n",TR("MSG_REPAIR"));
$oss = $oss . sprintf("    <td class=heading width=50 >%s</td>\n", TR("MSG_NUMBER_OF_ERRORS"));
$oss = $oss . sprintf("    <td class=heading width=50>%s</td>\n  </tr>\n</table>", TR("MSG_ERROR_CODE"));

$oss = $oss . sprintf("<div style='height:310px;overflow:auto'>\n");

if ($_REQUEST["clear"] == "1") // if user clicked the Clear button
{
  $clearError = "";
  $errorLogString = "";
  $clearLogString = sprintf("<clearErrorLog language='%s'/>", $language);
  ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", $clearLogString, $testLogString, $clearError);
}
  

if ($errorLogString != "")
{  
  $xmldoc = @new DomDocument($errorLogString);
  $rootElement = @$xmldoc->document_element();
  //echo htmlentities($xmldoc->html_dump_mem());  

  $oss = $oss . sprintf("<table width=100%% cellspacing=0 cellpadding=0>\n");
  $rowColor = "";
  $errorLogXpath = @xpath_new_context($xmldoc->document_element());
	$errorLogRecords = @xpath_eval($errorLogXpath, "/errorLogRecord");
	$num_errorLogRecords = count($errorLogRecords->nodeset); // should only be 1 - replace with find first match if such a thing exists in DOM
	for ($i=0; $i < $num_errorLogRecords; $i++)
	{
	  $errorLogRecord = $errorLogRecords->nodeset[$i];
    $testCaption = $errorLogRecord->get_attribute("testCaption");

	  $errorXpath = xpath_new_context($errorLogRecord);
	  $errorResults = xpath_eval($errorXpath, "/error");
	  $num_errors = count($errorResults->nodeset);
	  for ($j=0; $j < $num_errors; $j++)
	  {
		  $errorResult = $errorResults->nodeset[$j];

      $description = $errorResult->get_attribute("caption");
      $failedCount = $errorResult->get_attribute("count");
      $errorCode = $errorResult->get_attribute("errorCode");
      $errorcontent = $errorResult->get_content();

		
		  $repairContent = "";
		  $repairActionXpath = @xpath_new_context($errorResult);
		  $repairActions = @xpath_eval($repairActionXpath, "/repairAction");
		  $num_repairActions = count($repairActions->nodeset);
		  if ($num_repairActions)
		  { 
		    $repairAction = $repairActions->nodeset[0];
		    $repairContent = $repairAction->get_content();
		  }

      $details = @substr($errorcontent, 0, strpos($errorcontent, $repairContent)); // remove the repair action
      
      $oss = $oss . sprintf("  <tr bgcolor='%s'>\n", $rowColor);
      $oss = $oss . sprintf("    <td width=150>%s</td>\n", $testCaption);
      $oss = $oss . sprintf("    <td width=100>%s<br>%s</td>\n", $description, $details);
      $oss = $oss . sprintf("    <td width=300>%s</td>\n", $repairContent);
      $oss = $oss . sprintf("    <td width=50>%s</td>\n", $failedCount);
		  $oss = $oss . sprintf("    <td	width=50>%s</td>\n  </tr>\n", $errorCode);
 
        // Alternate the row color
	    if($rowColor == "")
	      $rowColor = "#eeeeee"; // make gray
	    else
	      $rowColor = ""; // make white
	  }
  }
  $oss = $oss . sprintf("</table>\n<div>\n");
	if ($num_errorLogRecords)
    $oss = $oss . sprintf("<table width=100%%><tr><td align=center>%s</td></tr></table>", MakeButton(TR("MSG_CLEAR_ERROR_LOG"),"document.location='errorlog.php?clear=1'"));
}

if ($HTTP_POST_VARS["save"] == "3")  
{ // Save page

  $result = SaveFile($HTTP_POST_VARS["filename"],$HTTP_POST_VARS["saveLocation"], "HP Insight Diagnostics " . TR("MSG_VERSION") . " " . getBuildVersion() . "<br>" . TR("Computer Name") . ": " . getComputerName() . $oss);
  
  if ($result == 1 || $result == 3)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_PLEASE_INSERT_FLOPPY"));
  else if ($result == 2)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_DISK_FULL"));
  else if ($result == 4)
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s - %s');\n</script>\n", TR("MSG_WRITEERROR"), TR("MSG_BAD_FORMAT"));
  else
    $oss = $oss . sprintf("<script language='Javascript'>\nalert('%s');\n</script>\n", TR("MSG_FILE_WRITE_COMPLETE"));
}
//hidden variables
$oss = $oss . sprintf("<input type=hidden name=save value=0>\n");
$oss = $oss . sprintf("<input type=hidden name=saveLocation value='floppy'>\n");

$oss = $oss . sprintf("<SCRIPT Language='Javascript'>\n");
$oss = $oss . sprintf("function saveFile(s)\n{\n");
$oss = $oss . sprintf("  if (s == 2 && document.errorLogForm.filename.value == '')\n{\n");
$oss = $oss . sprintf("  alert('%s');\n", TR("MSG_PLEASE_ENTER_FILENAME"));
$oss = $oss . sprintf("    return;\n }\n");

if (IsOnline())
{
  $oss = $oss . sprintf("    if (document.errorLogForm.location[1].checked)\n{\n");
  $oss = $oss . sprintf("      document.errorLogForm.saveLocation.value = 'harddrive';\n}\n");
}
else if (mountUSB("Transparent SCSI"))
{
  $oss = $oss . sprintf("    if (document.errorLogForm.location[1].checked)\ndocument.errorLogForm.saveLocation.value = 'diskonkey';\n");
  if ($usbFloppy)
    $oss = $oss . sprintf("    if (document.errorLogForm.location[2].checked)\ndocument.errorLogForm.saveLocation.value = 'usb';\n");
}
else if ($usbFloppy)
  $oss = $oss . sprintf("    if (document.errorLogForm.location[1].checked)\ndocument.errorLogForm.saveLocation.value = 'usb';\n");

$oss = $oss . sprintf("  document.errorLogForm.save.value = s;\n");
$oss = $oss . sprintf("  document.errorLogForm.submit();\n}\n");


if ($HTTP_POST_VARS["save"] == "2")  // check if file exits
{
  if ($HTTP_POST_VARS["saveLocation"] == "floppy")
  {
    if ($os == "Linux" || $os == "Unix" || !IsOnline())
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount " . getPathToFloppy() . "</systemCall>", $returnString, $systemCallError);
    $fileP = getPathToFloppy() . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "diskonkey")
  {  
    if ($os == "Linux" || $os == "Unix")
      ExecuteIOCommand($_SESSION["diagsDirectory"] . "hpdiagsai", "<systemCall>mount /mnt/diskonkey</systemCall>", $returnString, $systemCallError);
    $fileP = "/mnt/diskonkey" . $HTTP_POST_VARS["filename"];
  }
  else if ($HTTP_POST_VARS["saveLocation"] == "usb")
  {
    $fileP = "/mnt/usb/" . $HTTP_POST_VARS["filename"];
  }
  else
    $fileP = $_SESSION["diagsDirectory"] . $HTTP_POST_VARS["filename"];

  if (file_exists($fileP))
  {
    $oss = $oss . sprintf("if  (!window.confirm('Saving will overwrite the existing file. Do you wish to continue?'))\n{");
    $oss = $oss . sprintf("    \n  document.errorLogForm.save.value=0;\n");
    $oss = $oss . sprintf("    document.errorLogForm.submit();\n   }\n");
    $oss = $oss . sprintf("else\n");
    $oss = $oss . sprintf("{\n");
    $oss = $oss . sprintf("  document.errorLogForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    $oss = $oss . sprintf("  document.errorLogForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    $oss = $oss . sprintf("  saveFile(3);\n}\n");

  }
  else
  {
    $oss = $oss . sprintf("  document.errorLogForm.saveLocation.value='%s';\n", $HTTP_POST_VARS["saveLocation"]);
    $oss = $oss . sprintf("  document.errorLogForm.filename.value='%s';\n",$HTTP_POST_VARS["filename"]);
    $oss = $oss . sprintf("  saveFile(3);\n");
  } 
   
}
if ($HTTP_POST_VARS["save"] == "1") // keep savePrompt displayed
  $oss = $oss . sprintf("document.getElementById('savePrompt').style.display = 'inline';\ndocument.getElementById('savePrompt').style.visibility = 'visible';\n");
$oss = $oss . sprintf("</script>\n");
$oss = $oss . sprintf("</form>\n</body>\n<script language='Javascript' src='norightclick.js'></script></html>\n");

printf("%s", $oss);
?>
